
; Asar directives
hirom
table charset.tbl,rtl


; 0 free bytes before C32341
; 3 free bytes before C3235C
; 2 free byte before C33E3F
; 27 free bytes before C33F99
; 61 free bytes before C341FE
; 18 free bytes at C3386C (relocated cursor positions)


; =============================[ Segment edits ]===============================

org $C32335 ; Handle clicked option in Config menu
         TDC             ; Clear A			<- JSR $2D0B would save 2 bytes
         LDA $4B         ; Cursor slot			<- Done only once now
         ASL A           ; Double it
         TAX             ; Index it
         LDA $4A         ; On first page?
         BNE C32342      ; Branch if not
         JMP (C3234A,X)  ; Handle P1 option		<- Now a label

warnpc $C32341 ; For preserving RTS there
org $C32342

C32342:  JMP ($235C,X)   ; Handle P2 option

; Jump table for clicks in Config menu (page 1)		<- Could use a branch system to save space
C3234A:  dw $2341        ; Bat.Mode   (NOP)
         dw $2341        ; Bat.Speed  (NOP)
         dw $2341        ; Msg.Speed  (NOP)
         dw $2368        ; Cmd.Set
         dw $2341        ; Gauge      (NOP)
         dw $2341        ; Sound      (NOP)
         dw $2341        ; Cursor     (NOP)
         dw $2341        ; Reequip    (NOP)
         dw btnclik      ; Button			<- New
         dw $2379        ; Controller

warnpc $C3235C


org $C3026D ; Jump table for field menu commands	<- Now labels
         dw C3478E       ; 49: Initialize Button Settings menu
         dw C347AB       ; 4A: Sustain Button Settings menu


org $C322D0 ; 0E: Sustain Config menu
         CMP #$09        ; Bottom of Pg1?		<- Originally #$08


org $C33A40 ; 51: Scroll to Config page 1
         LDA #$09        ; New cursor row		<- Originally #$08


org $C338E0 ; Draw Config menu, load navigation data, create arrow
         LDX #$4903      ; Text ptrs loc		<- Removed redundant color-setting code before this
         LDY #$0004      ; Strings: 2
         JSR $69BA       ; Draw Cursor, Contr.
         LDA #$20        ; Palette 0			<- JSR $C2F2 would save a byte
         STA $29         ; Color: User's
         LDX #$4907      ; Text ptrs loc
         LDY #$0004      ; Strings: 2
         JSR $69BA       ; Draw Fast, Slow
         JSR C33B8C      ; Draw Active, Wait		<- Using labels from here on out
         JSR C33BB7      ; Draw Bat.Spd nums
         JSR C33BF2      ; Draw Msg.Spd nums
         JSR C33C33      ; Draw Window, Short
         JSR C33C5C      ; Draw On and Off
         JSR C33C85      ; Draw Stereo, Mono
         JSR C33CB0      ; Draw Reset, Memory
         JSR C33CDB      ; Draw Optimum, Empty
         JSR C33DDA      ; Draw Btn.Set options		<- New
         JSR C33D06      ; Draw Single/Multiple
         NOP


org $C33932 ; Bottom part of the function above		<- Now labels
         JSR C33FFD      ; Draw M.Order options
         JSR C340EA      ; Draw skin numbers
         JSR C34133      ; Draw skin palette
         JSR C341C3      ; Draw RGB info


org $C3386B ; Navigation data for Config page 1
         db $0A          ; 10 rows			<- Originally $09


org $C33861 ; Handle D-Pad for Config page 1
         LDY #C3386C    ; C3/386C			<- Now a label (for relocating cursor positions)


org $C34963 ; Positioned text for Config page 1
         dw $3E35        ; Multiple			<- Shifted down


org $C34A13 ; Positioned text for Config page 1
         dw $3E25        ; Single			<- Shifted down


org $C32322 ; Handle left and right for Config menu
         JMP C33D2F      ; Change settings		<- Now a label


org $C32398 ; Reset player's skin colors
         JMP C341C3      ; Redraw RGB info		<- Now a label

org $C323A4 ; Reset player's font color
         JMP C341C3      ; Redraw RGB info		<- Now a label


; ============================[ Optimizations ]================================

org $C33B8C

; Draw text string in gray
draw28:  LDA #$28        ; Palette 2
C302F_:  STA $29         ; Set attribs
         JMP $02F9       ; Draw string

; Handle Config changes with D-Pad
C33D2F:  LSR A           ; C = Right key
         PHP             ; Memorize it
         TDC             ; Clear A
         LDA $4B         ; Cursor slot			<- JSR $2D0B would save 2 bytes
         ASL A           ; Double it
         TAX             ; Index it
         LDA $4A         ; On first page?
         BEQ C33D40      ; Branch if so
         JSR $0EA3       ; Sound: Cursor
         PLP             ; C = Right key
         JMP (C33D55,X)  ; Handle page 2
C33D40:  CPX #$000A      ; On Sound's row?
         BEQ C33D4_      ; Branch if so
         JSR $0EA3       ; Sound: Cursor
C33D4_:  PLP             ; C = Right key
         LDA #$80        ; Common option bit
         JMP (C33D43,X)  ; Handle page 1

; Jump table for updating game options
C33D43:  dw C33D61       ; Bat.Mode
         dw C33D7A       ; Bat.Speed
         dw C33DAB       ; Msg.Speed
         dw C33DE8       ; Cmd.Set
         dw C33E01       ; Gauge
         dw C33E1A       ; Sound
         dw C33E4E       ; Cursor
         dw C33E6D       ; Reequip
         dw _33F8D       ; Button
         dw C33E86       ; Controller
C33D55:  dw C33E9F       ; Mag.Order
         dw C33ECD       ; Window
         dw C33F01       ; Viewed color
         dw C33F3C       ; R
         dw C33F3C       ; G
         dw C33F3C       ; B
;------------------------------------------------------------------------------
; Update Bat.Speed
C33D7A:  LDA $1D4D       ; Game options
         AND #$07        ; Get Bat.Speed
         TRB $1D4D       ; Clear in config
         BCC C33D95      ; If pushing left
         CMP #$05        ; On "6" now?
         BEQ C33D9E      ; Retain if so
         INC A           ; Speed +1
         INC A           ; Speed +1
C33D95:  BEQ C33D9E      ; Retain if on "1"
         DEC A           ; Speed -1
C33D9E:  TSB $1D4D       ; Update config
C33BB7:  LDY #$496E      ; Text pointer
         JSR draw28      ; Draw 1-6 in gray
         LDX #$3A24      ; Tilemap ptr (-1)
         LDA $1D4D       ; Game options
         AND #$07        ; Get Bat.Speed
         BRA C33C24      ; Draw user value

; Update Msg.Speed
C33DAB:  PHP             ; Save direction
         LDA $1D4D       ; Game options
         AND #$70        ; Get Msg.Speed
         TRB $1D4D       ; Clear in config
         LSR A           ; Put in b3-b5			<- JSR $CC33 would save a byte
         LSR A           ; Put in b2-b4
         LSR A           ; Put in b1-b3
         LSR A           ; Now 0-5
         PLP             ; Pushing left?
         BCC C33DCA      ; Branch if so
         CMP #$05        ; On "6" now?
         BEQ C33DD3      ; Retain if so
         INC A           ; Speed +1
         INC A           ; Speed +1
C33DCA:  CMP #$00        ; On "1" now?
         BEQ C33DD3      ; Retain if so
         DEC A           ; Speed -1
C33DD3:  ASL A           ; Speed x2
         ASL A           ; Speed x4
         ASL A           ; Speed x8
         ASL A           ; Speed x16
         TSB $1D4D       ; Update config
C33BF2:  LDY #$497C      ; Text pointer
         JSR draw28      ; Draw 1-6 in gray
         LDX #$3AA4      ; Tilemap ptr (-1)
         LDA $1D4D       ; Game options
         AND #$70        ; Get Msg.Speed
         LSR A           ; Put in b3-b5			<- JSR $CC33 would save a byte
         LSR A           ; Put in b2-b4
         LSR A           ; Put in b1-b3
         LSR A           ; Now 0-5
C33C24:  JMP C340E_      ; Draw user speed

; Update Bat.Mode
C33D61:  LDA #$08        ; Bat.Mode bit
         TRB $1D4D       ; Mode: Active
         BCC C33B8C      ; If pushing left
         TSB $1D4D       ; Mode: Wait
C33B8C:  PEA $2820       ; Active mode pals
         LDA $1D4D       ; Game options
         AND #$08        ; Wait mode?
         BEQ C33B8_      ; Branch if not
         PLY             ; Unstack palettes
         PEA $2028       ; Wait mode pals
C33B8_:  PLA             ; Active's palette
         LDY #$49F1      ; Text pointer
         JSR C302F_      ; Draw "Active"
         LDY #$4918      ; Text pointer
         BRA C33CA7      ; Draw "Wait"

; Update Cmd.Set mode
C33DE8:  TRB $1D4D       ; Mode: Window
         BCC C33C33      ; If pushing left
         TSB $1D4D       ; Mode: Short
C33C33:  PEA $2028       ; Short mode pals
         LDA $1D4D       ; Short mode?
         BMI C33C3_      ; Branch if so
         PLY             ; Unstack palettes
         PEA $2820       ; Window mode pals
C33C3_:  PLA             ; Window's palette
         LDY #$49FA      ; Text pointer
         JSR C302F_      ; Draw "Window"
         LDY #$492D      ; Text pointer
         BRA C33CA7      ; Draw "Short"

; Update gauge mode
C33E01:  TRB $1D4E       ; Gauge: On
         BCC C33C5C      ; If pushing left
         TSB $1D4E       ; Gauge: Off
C33C5C:  PEA $2820       ; On mode pals
         LDA $1D4E       ; Gauges on?
         BPL C33C5_      ; Branch if so
         PLY             ; Unstack palettes
         PEA $2028       ; Off mode pals
C33C5_:  PLA             ; On's palette
         LDY #$4935      ; Text pointer
         JSR C302F_      ; Draw "On"
         LDY #$493A      ; Text pointer
         BRA C33CA7      ; Draw "Off"

; Update sound mode
C33E1A:  LDA #$20        ; Sound option bit
         TRB $1D4E       ; Option: Stereo
         BCS C33E2F      ; If pushing right
         TDC             ; Volume: Stereo
         BRA C33E2_      ; Branch below
C33E2F:  TSB $1D4E       ; Option: Mono
         LDA #$FF        ; Volume: Mono
C33E2_:  JSR $3E3F       ; Adjust volume
         JSR $0EA3       ; Sound: Cursor
C33C85:  PEA $2820       ; Stereo mode pals
         LDA $1D4E       ; Game options
         AND #$20        ; Stereo?
         BEQ C33C8_      ; Branch if so
         PLY             ; Unstack palettes
         PEA $2028       ; Mono mode pals
C33C8_:  PLA             ; Stereo's palette
         LDY #$4940      ; Text pointer
         JSR C302F_      ; Draw "Stereo"
         LDY #$4949      ; Text pointer
C33CA7:  PLA             ; Mono's palette
         JMP C302F_      ; Draw "Mono"

; Update Cursor mode
C33E4E:  LDA #$40        ; Cursor bit
         TRB $1D4E       ; Mode: Reset
         BCC C33CB0      ; If pushing left
         TSB $1D4E       ; Mode: Memory
         JSR $7068       ; Reset positions
C33CB0:  PEA $2820       ; Reset mode pals
         LDA $1D4E       ; Game options
         ASL A           ; Cursor memory?
         BPL C33CB_      ; Branch if not
         PLY             ; Unstack palettes
         PEA $2028       ; Memory mode pals
C33CB_:  PLA             ; Reset's palette
         LDY #$4A03      ; Text pointer
         JSR C302F_      ; Draw "Reset"
         LDY #$4950      ; Text pointer
         BRA C33CA7      ; Draw "Memory"

; Update Reequip mode
C33E6D:  LDA #$10        ; Reequip bit
         TRB $1D4E       ; Mode: Optimum
         BCC C33CDB      ; If pushing left
         TSB $1D4E       ; Mode: Empty
C33CDB:  PEA $2820       ; Optimum mode pals
         LDA $1D4E       ; Game options
         AND #$10        ; Optimum mode?
         BEQ C33CD_      ; Branch if so
         PLY             ; Unstack palettes
         PEA $2028       ; Empty mode pals
C33CD_:  PLA             ; Optimum's palette
         LDY #$4959      ; Text pointer
         JSR C302F_      ; Draw "Optimum"
         LDY #$4A0B      ; Text pointer
         BRA C33CA7      ; Draw "Empty"

; Update Controller mode
C33E86:  TRB $1D54       ; Mode: Single
         BCC C33D06      ; If pushing left
         TSB $1D54       ; Mode: Multiple
C33D06:  PEA $2820       ; Single mode pals
         LDA $1D54       ; Single mode?
         BPL C33D0_      ; Branch if so
         PLY             ; Unstack palettes
         PEA $2028       ; Multiple mode pals
C33D0_:  PLA             ; Single's palette
         LDY #$4A13      ; Text pointer
         JSR C302F_      ; Draw "Single"
         LDY #$4963      ; Text pointer
         BRA C33CA7      ; Draw "Multiple"

; Handle wallpaper selection
C33ECD:  LDA $1D4E       ; Game options
         AND #$0F        ; Get wallpaper
         TRB $1D4E       ; Clear in config
         BCC C33EE5      ; If pushing left
         CMP #$07        ; On "8" now?
         BEQ C33EEE      ; Retain if so
         INC A           ; Skin number +1
         INC A           ; Skin number +1
C33EE5:  BEQ C33EEE      ; Retain if on "1"
         DEC A           ; Skin number -1
C33EEE:  TSB $1D4E       ; Set new skin
         JSR C340EA      ; Redraw values
         JSR $3A87       ; Refresh skin
         JMP C341C3      ; Draw RGB info
;------------------------------------------------------------------------------
; Update Mag.Order
C33E9F:  LDA $1D54       ; Game options
         AND #$07        ; Get Mag.Order
         TRB $1D54       ; Clear in config
         BCC C33EB7      ; If pushing left
C33EAC:  CMP #$05        ; On "6"?
         BEQ C33EC0      ; Retain if so
         INC A           ; Order +1
         INC A           ; Order +1
C33EB7:  BEQ C33EC0      ; Retain if "1"
         DEC A           ; Order -1
C33EC0:  TSB $1D54       ; Update config
;        BRA C33FFD      ; Redraw text

; Draw Mag.Order settings
C33FFD:  LDY #$4AA5      ; Text pointer
         JSR draw28      ; Draw 1-6 in gray
         TDC             ; Clear A
         LDA $1D54       ; Game options
         AND #$07        ; Get Mag.Order
         PHA             ; Memorize it
         ASL A           ; x2
         ASL A           ; x4
         REP #$21        ; 16-bit A; C-
         ADC #$41A5      ; Add base pos
         TAX             ; Set position
         SEP #$20        ; 8-bit A
         PLA             ; Get Mag.Order
         JSR C3410F      ; Draw user value
         JMP C3403B      ; Draw spell types

; Tilemap pointers for Mag.Order strings
C340CC:  dw $4329        ; Spell type C
         dw $42A9        ; Spell type B
         dw $4229        ; Spell type A
;------------------------------------------------------------------------------
; Change viewed color in Config
C33F01:  PHP             ; Save D-Pad
         LDA $1D54       ; Game options
         AND #$38        ; Viewed color
         TRB $1D54       ; Clear in config
         LSR A           ; Put in b2-b4
         LSR A           ; Put in b1-b3
         LSR A           ; Now 0-7
         PLP             ; Pushing left?
         BCC C33F1C      ; Branch if so
         CMP #$07        ; On last color?
         BEQ C33F25      ; Retain if so
         INC A           ; Color number +1
         INC A           ; Color number +1
C33F1C:  DEC A           ; Color number -1
         BPL C33F25      ; If wasn't on font
         INC A           ; Color number +1
C33F25:  ASL A           ; Color number x2
         ASL A           ; Color number x4
         ASL A           ; Color number x8
         TSB $1D54       ; Update config
         JSR C34133      ; Redraw arrow
         BRA C341C3      ; Draw RGB info
;------------------------------------------------------------------------------
; Pointers to color components
colptr:  db $02          ; Red
         db $01          ; Green
         db $00          ; Blue

; Update component of font or skin color
C33F3C:  JSR $41FE       ; Separate RGB
         TDC             ; Clear A
         LDA $4B         ; Cursor slot			<- JSR C3BFC2 would save a byte
         TAX             ; Index it
         LDA.L colptr-3,X; Color index
         TAX             ; Index it
         LDA $0B         ; Semi-auto keys
         LSR A           ; Pushing right?
         LDA $E0,X       ; Color component
         BCS C33F4F      ; Branch if right
         BEQ C33F55      ; Branch if 0
         DEC A           ; Component -1
         DEC A           ; Component -1
C33F4F:  CMP #$1F        ; Component = 31?
         BEQ C33F55      ; Branch if so
         INC A           ; Component +1
C33F55:  STA $E0,X       ; Save component
         JSR $4221       ; Merge RGB
;        BRA C33FC4      ; Apply changes

; Apply player's skin or font colors after changes
C33FC4:  JSR skncol      ; Viewed color
         BEQ C33FF2      ; Branch if font
;        CLC             ; Prepare ADC
         ADC $4216       ; Add skin x15
         TAX             ; Index sum
         REP #$20        ; 16-bit A
         LDA $9A         ; Updated color
         STA $1D55,X     ; Set as user's
         SEP #$20        ; 8-bit A
         LDY $4216       ; Palette index
         LDX $00         ; Dst index: 0
C33FB1:  LDA $1D57,Y     ; Player color
         STA $7E312B,X   ; Put in palette
         INY             ; Src index +1
         INX             ; Dst index +1
         CPX #$000E      ; Done 7 colors?
         BNE C33FB1      ; Loop if not
         BRA C341C3      ; Redraw RGB info

; Fork: Font
C33FF2:  LDY $9A         ; Updated color
         STY $1D55       ; Put in options
         JSR $3F99       ; Put in palettes
C33FFA: ;JMP C341C3      ; Redraw RGB info

; Draw RGB gauges and values in Config menu
C341C3:  JSR $3950       ; Reset gauges
         JSR skncol      ; Viewed color
         BEQ C341E7      ; Branch if font		<- Branching to TAX would save 5 bytes
;        CLC             ; Prepare ADC
         ADC $4216       ; Add skin x15
         TAX             ; Index sum
         LDY $1D55,X     ; Skin color
         BRA C341EA      ; Skip a line
C341E7:  LDY $1D55       ; Font color
C341EA:  STY $9A         ; Memorize it
         JSR $41FE       ; Separate RGB
         JSR $4263       ; Draw B info
         JSR $41FE       ; Separate RGB
         JSR $4250       ; Draw G info
         JSR $41FE       ; Separate RGB
         JMP $423D       ; Draw R info
;------------------------------------------------------------------------------
; Get color to view in Config menu
skncol:  LDA $1D4E       ; Game options
         AND #$0F        ; Get wallpaper
         STA $4202       ; Set multiplicand
         LDA #$0E        ; Palette size
         STA $4203       ; Set multiplier
skncol_: TDC             ; Clear A
         LDA $1D54       ; Game options
         AND #$38        ; Viewed color
         LSR A           ; Put in b2-b4
         LSR A           ; Put in b1-b3
         RTS
;------------------------------------------------------------------------------

 ; Skip mono/stereo sound handler
warnpc $C33E3F
org $C33E4E

;------------------------------------------------------------------------------
; Draw wallpaper values
C340EA:  LDY #$4A93      ; Text pointer
         JSR draw28      ; Draw 1-8 in gray
         LDX #$43A4      ; Tilemap ptr (-1)
         LDA $1D4E       ; Game options
         AND #$0F        ; Get wallpaper
C340E_:  TAY             ; Memorize it
         ASL A           ; x2
         ASL A           ; x4
.loop    INX             ; Tilemap ptr +1
         DEC A           ; Counter -1
         BPL .loop       ; Loop till < 0
         TYA             ; Skin number
C3410F:  CLC             ; Prepare ADC
         ADC #$B5        ; Convert to text
         STA $F9         ; Add to string
         STZ $FA         ; End string
         STX $F7         ; Set position
         LDY #$00F7      ; 00/00F7
         STY $E7         ; Set src LBs
         STZ $E9         ; Source HB: 0
         LDA #$20        ; Palette 0			<- JSR $C2F2 would save a byte
         STA $29         ; Color: User's
         JMP $02FF       ; Draw user value
;------------------------------------------------------------------------------
; Draw all three Mag.Order spell types
C3403B:  TDC             ; Clear A
         LDA $1D54       ; Game options
         AND #$07        ; Get Mag.Order
         ASL A           ; x2
         ASL A           ; x4
         TAX             ; Index it
         LDY #$0003      ; Strings: 3
C3404C:  PHY             ; Save counter
         PHX             ; Save index
         JSR C34058      ; Draw string			<- Annexable (saves 4 bytes)
         PLX             ; String index
         PLY             ; Strings left
         INX             ; Point to next
         DEY             ; One less left
         BNE C3404C      ; Loop till last
         RTS

; Draw current Mag.Order spell type
C34058:  TDC             ; Clear A
         LDA.L C340D2,X  ; Text pointer
         LDX #$9E8B      ; 7E/9E8B
         STX $2181       ; Set WRAM LBs
         TAX             ; Index pointer
         LDA #$0A        ; Letters: 10
.loop    PHA             ; Memorize it
         LDA $C34AD3,X   ; Letter
         STA $2180       ; Add to string
         INX             ; Index +1
         PLA             ; Letters left
         DEC A           ; One less left
         BNE .loop       ; Loop till last
         STZ $2180       ; End string
         DEY             ; Lines left -1
         TYA             ; Put it in A
         ASL A           ; Double it
         TAX             ; Index it
         REP #$20        ; 16-bit A
         LDA.L C340CC,X  ; Tilemap ptr
         STA $7E9E89     ; Set position
         SEP #$20        ; 8-bit A
         JMP $7FD9       ; Draw string

; Relative pointers to Mag.Order strings
C340D2:  db $00,$0A,$14  ; Healing, Attack, Effect
         db $00          ; ...
         db $00,$14,$0A  ; Healing, Effect, Attack
         db $00          ; ...
         db $0A,$14,$00  ; Attack, Effect, Healing
         db $00          ; ...
         db $0A,$00,$14  ; Attack, Healing, Effect
         db $00          ; ...
         db $14,$00,$0A  ; Effect, Healing, Attack
         db $00          ; ...
         db $14,$0A,$00  ; Effect, Attack, Healing
;------------------------------------------------------------------------------
; Draw wallpaper palette and arrow in Config
C34133:  LDA #$3C        ; Palette 7
         LDY #$4AC9      ; Text pointer
         JSR C302F_      ; Draw palette
         LDY #C3419D     ; Text pointer
         JSR $02F9       ; Erase arrow
         PEA $2820       ; Font mode pals
         JSR skncol_     ; Viewed color
         BEQ C34171      ; Branch if font
         TAX             ; Index it
         REP #$20        ; 16-bit A
         LDA #$20D4      ; Arrow tile data
         STA $7E44F3,X   ; Put in tilemap
         SEP #$20        ; 8-bit A
         PLY             ; Unstack palettes
         PEA $2028       ; Window mode pals
C34171:  PLA             ; Font's palette
         LDY #$4AB3      ; Text pointer
         JSR C302F_      ; Draw "Font"
;        PLA             ; Window's palette
         LDY #$4ABA      ; Text pointer
         JMP C33CA7      ; Draw "Window"

; Positioned spaces for blanking color selection arrow
C3419D:  dw $44F5 : db "       ",$00
;------------------------------------------------------------------------------

; Cursor positions for Config page 1
C3386C:  dw $2960        ; Bat.Mode
         dw $3960        ; Bat.Speed
         dw $4960        ; Msg.Speed
         dw $5960        ; Cmd.Set
         dw $6960        ; Gauge
         dw $7960        ; Sound
         dw $8960        ; Cursor
         dw $9960        ; Reequip
         dw $A960        ; Button			<- New
         dw $B960        ; Controller


; =========================[ Button Settings menu ]============================

; Window layout for Button Settings menu
C34A7C:  dw $590B,$161C  ; 30x24 at $590B (Main)	<- Could reuse Config menu's (C3/39E2)
C34A80:  dw $58B7,$0206  ; 08x04 at $58B7 (Title)	<- Could reuse Config menu's if no plan to resize in either menu

; Navigation data for Button Settings menu
C34AE3:  db $00          ; Wraps on all sides
         db $00          ; Initial column
         db $00          ; Initial row
         db $01          ; 1 column
         db $07          ; 7 rows

; Cursor positions for Button Settings menu
C34AE8:  dw $2310        ; A
         dw $3B10        ; B
         dw $5310        ; X
         dw $6B10        ; Y
         dw $8310        ; L
         dw $9B10        ; R
         dw $B310        ; Select

; Text shifting table for Button Settings menu
C34AA3:  db $23,$03,$00  ; Title			<- Shifted upward to center title, separate entry for "A Button"
         db $0C,$00,$00  ; A
         db $0C,$04,$00  ; A's options
         db $0C,$08,$00  ; B
         db $0C,$0C,$00  ; B's options
         db $0C,$10,$00  ; X
         db $0C,$14,$00  ; X's options
         db $0C,$18,$00  ; Y
         db $0C,$1C,$00  ; Y's options
         db $0C,$20,$00  ; L
         db $0C,$24,$00  ; L's options
         db $0C,$28,$00  ; R
         db $0C,$2C,$00  ; R's options
         db $0C,$30,$00  ; Select
         db $0C,$34,$00  ; Select's options
;        db $0C,$38,$00  ; Nothing
;        db $0C,$3C,$00  ; Nothing
         db $00          ; End

; Handle D-Pad for Button Settings menu
C34ADA:  JSR $072D       ; Handle D-Pad
C34ADD:  LDY #C34AE8     ; C3/4AE8
         JMP $0640       ; Relocate cursor







 ; Skip function that applies player's font color
warnpc $C33F99
org $C33FAD







; Update Button Settings mode
_33F8D:  LDA #$40        ; Btn.Set bit
         TRB $1D54       ; Mode: Default
         BCC C33DDA      ; If pushing left
         TSB $1D54       ; Mode: Custom

; Fork: Draw Btn.Set settings
C33DDA:  JSL $C3A436     ; Apply key setup
         PEA $2820       ; Default mode pals
         ASL A           ; Default setup?
         BPL .go         ; Branch if so
         PLY             ; Unstack palettes
         PEA $2028       ; Custom mode pals
.go      LDY #C34E48     ; Text pointer
         PLA             ; Default's pal
         JSR C302F_      ; Draw "Default"
;        PLA             ; Custom's pal
         LDY #C34E4F     ; Text pointer
         JMP C33CA7      ; Draw "Custom"







; 49: Initialize Button Settings menu
C3478E:  JSR $352F       ; Reset/Stop stuff
         JSR $6A28       ; Clear BG2 map A		<- Added for convenience (not in original code)
         LDY #C34A7C     ; C3/4A7C
         JSR $0341       ; Draw main box
         LDY #C34A80     ; C3/4A80
         JSR $0341       ; Draw title box
         JSR $0E52       ; Upload windows
         JSR $6A15       ; Clear BG1 map A
;        JSR $6A19       ; Clear BG1 map B
         JSR $6A3C       ; Clear BG3 map A
;        JSR $6A41       ; Clear BG3 map B
         JSR $C2F7       ; Color: Blue
         LDX #C35021     ; Text ptrs loc
         LDY #$0010      ; Strings: 8
         JSR $69BA       ; Draw title, keys
         JSR C34AF6      ; Draw options
         JSR $0E28       ; Upload blank BG1
         JSR $0E6E       ; Upload text
         JSR $466F       ; Set to shift text		<- Reuses unrelated code to save space
         LDY #C34AA3     ; C3/4AA3
         STY $4352       ; Set shift src LBs
         LDY #C34AE3     ; C3/4AE3
         JSR $05FE       ; Load navig data
         JSR C34ADD      ; Relocate cursor
         JSR $07B0       ; Queue cursor OAM
         LDX #$4A01      ; Next: Fade-in
         STX $26         ; Queue: Sustain
         JMP $3541       ; BRT:1 + NMI







; 4A: Sustain Button Settings menu
C347AB:  JSR $0F39       ; Queue BG3 upload
         JSR C34ADA      ; Handle up/down

; Fork: Handle Start
         LDA $09         ; No-autofire keys
         BIT #$10        ; Pushing Start?
         BEQ C347CB      ; Branch if not
         STZ $E0         ; Covered actions
         LDA #$06        ; 1st: Select
.loop1   PHA             ; Memorize it
         JSR keyact      ; Assigned action
         TAX             ; Set as counter
         TDC             ; Clear A
         SEC             ; Set Carry
.loop2   ROL A           ; Rotate Carry
         DEX             ; Counter -1
         BNE .loop2      ; Loop till 0
         TSB $E0         ; Set action bit
         PLA             ; Current button
         DEC A           ; Move upward
         BPL .loop1      ; Loop till "A"
         LDA $E0         ; Covered actions
         CMP #$3F        ; Has all cases?
         BNE C347DB      ; Fail if not
         JSR $A5C4       ; Apply user keys
         LDX #$0D00      ; Next: Fade-out		<- JSR $2E7F would save 2 bytes (JMP $2E7A?)
         STX $26         ; Queue: Config
         JMP $0EB2       ; Sound: Click

; Fork: Invalid combination
C347DB:  JSR $0EC0       ; Play buzzer			<- JMP $2B32 would save 3 bytes
         JMP $305D       ; Pixelate screen
C347DB_: RTS

; Fork: Handle left and right
C347CB:  LDA $0B         ; Semi-auto keys
         BIT #$03        ; Using left/right?
         BEQ C347DB_     ; Exit if not
         LDA $4B         ; Button number
         JSR keyact      ; Assigned action
         PHP             ; Save Carry
         PHA             ; Save action
         LDA $0B         ; Semi-auto keys
         LSR A           ; Pushing left?
         PLA             ; Button action
         BCC C34C24      ; If pushing left

; Fork: Pushing right
C34C19:  INC A           ; Move right
         CMP #$07        ; Impossible?
         BNE C34C2F      ; Branch if not

; Fork: Pushing left
C34C24:  DEC A           ; Move left
         BNE C34C2F      ; If possible
         INC A           ; Move right

; Fork: Apply changes
C34C2F:  LDY #$00F0      ; Nibble mask
         PLP             ; B, Y, or R?
         BCS .low        ; Branch if so
         CPX #$0003      ; Select button?
         BEQ .low        ; Branch if so
         LDY #$000F      ; Replace mask
         ASL A           ; Action: b1-b4
         ASL A           ; Action: b2-b5
         ASL A           ; Action: b3-b6
         ASL A           ; Action: b4-b7
.low     STA $E0         ; Save action
         STY $E1         ; Save mask
         LDA $1D50,X     ; Game options
         AND $E1         ; Clear action
         ORA $E0         ; Set chosen one
         STA $1D50,X     ; Save changes
;        BRA C34AF6      ; Redraw options







; Draw all options in Button Settings menu
C34AF6:  LDY #$800D      ; Tilemap ptr
         STY $FC         ; Set base pos
         LDA #$06        ; 1st: Select

; Fork: Draw all options for button in gray
.loop1   PHA             ; Save button
         JSR $3519       ; Set pos, WRAM
         LDX #$FFFF      ; Letter index: -1
.loop2   INX             ; Letter index +1
         LDA.L C3509E,X  ; Letter
         STA $2180       ; Add to string
         BNE .loop2      ; Loop till last
         LDA #$24        ; Palette 1
         STA $29         ; Color: Gray
         JSR $7FD9       ; Draw all in gray

; Fork: Define position for lit option
         JSR $3519       ; WRAM: 7E/9E8B
         LDA #$20        ; Palette 0			<- JSR $C2F2 would save a byte
         STA $29         ; Color: User's
         LDA $01,S       ; Current button
         JSR keyact      ; Assigned action
         TAX             ; Index it
;        TDC             ; Clear A			<- Clears B, which already is given TAX
         LDA.L actpos-1,X; Relative pos
         REP #$21        ; 16-bit A; C-
         ADC $FC         ; Add base pos
         STA $7E9E89     ; Set position

; Fork: Draw lit option
         TXA             ; Action number
         ASL A           ; Double it
         TAX             ; Index it
         LDA.L C3503F-2,X; Text pointer
         TAX             ; Index it
         SEP #$20        ; 8-bit A
.loop4   LDA $C30000,X   ; Letter
         STA $2180       ; Add to string
         INX             ; Letter index +1
         INC A           ; Added a space?
         BNE .loop4      ; Loop if not
         STZ $2180       ; End string
         JSR $7FD9       ; Draw lit option

; Fork: Handle next button
         DEC $FD         ; Point 4 rows up
         LDY $FC         ; Tilemap ptr
         PLA             ; Button index
         DEC A           ; Button index -1
         BPL .loop1      ; Loop till "A"
C34AF_:  RTS







; Handle click on "Custom" option
btnclik: LDA $1D54       ; Game options
         ASL A           ; Custom buttons?
         BPL C34AF_      ; Exit if not
         LDX #$0049      ; Next: Fade-out
         STX $26         ; Queue: Key menu
         JMP $0EB2       ; Sound: Click			<- Could jump to bottom of C347AB







; Get action assigned to current button
keyact:  PHA             ; Push button
         TDC             ; Clear A
         PLA             ; Pull button
         LSR A           ; Halve it
         TAX             ; Index it
         PHP             ; Save Carry
         LDA $1D50,X     ; Button actions
         BCS .low        ; If B, Y, or R
         CPX #$0003      ; Select button?
         BEQ .low        ; Branch if so
         LSR A           ; Action: b3-b6
         LSR A           ; Action: b2-b5
         LSR A           ; Action: b1-b4
         LSR A           ; Now 0-7
.low     AND #$0F        ; Clear b4-b7
         PLP             ; Restore Carry
         RTS









; Text pointers for Button Settings menu
C35021:  dw C35093       ; Title
         dw C351F5       ; A Button
         dw _351F9       ; B Button
         dw C351FD       ; X Button
         dw C35201       ; Y Button
         dw C35205       ; L Button
         dw C35209       ; R Button
         dw C3520D       ; SEL Button
C3503F:  dw C3509E       ; OK
         dw C350A5       ; Cancel
         dw C350AC       ; Menu
         dw C350B3       ; Party
         dw C350BB       ; Row
         dw C350C2       ; Def

; Positioned blue text for Button Settings menu		<- Could append title manually via code to every key name
C35093:  dw $7939 : db "Button",$00
C351F5:  dw $7991 : db "A Button",$00
_351F9:  dw $7A91 : db "B Button",$00
C351FD:  dw $7B91 : db "X Button",$00
C35201:  dw $7C91 : db "Y Button",$00
C35205:  dw $7D91 : db "L Button",$00
C35209:  dw $7E91 : db "R Button",$00
C3520D:  dw $7F91 : db "SEL Button",$00

; Relative positions for Button Settings menu
actpos:  db $00              ; OK
         db C350A5-C3509E*2  ; Cancel
         db C350AC-C3509E*2  ; Menu
         db C350B3-C3509E*2  ; Party
         db C350BB-C3509E*2  ; Row
         db C350C2-C3509E*2  ; Def

; Text for button settings
C3509E:  db "OK "
C350A5:  db "Cancel "
C350AC:  db "Menu "
C350B3:  db "Party "
C350BB:  db "Row "
C350C2:  db "Def ",$00

; Positioned text for Config page 1
C34E48:  dw $3DA5 : db "Default",$00
C34E4F:  dw $3DB5 : db "Custom",$00



warnpc $C341FE
